commit e211c1bb269498942db0cbb6d284524951fc05f2
Author: freddy77 <freddy77>
Date:   Thu Mar 19 13:11:41 2009 +0000

    make dblib tests compile with ms dblib

diff --git a/ChangeLog b/ChangeLog
index 4fb20e9..fcf10ee 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Thu Mar 19 14:11:31 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/unittests/common.c src/dblib/unittests/common.h:
+	* src/dblib/unittests/null.c src/dblib/unittests/t0021.c:
+	* misc/prepare_win32.sh:
+	- make dblib tests compile with ms dblib
+
 Tue Mar 17 14:34:15 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/unittests/Makefile.am: fix distribution
 
@@ -1417,4 +1423,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2753 2009/03/17 13:34:37 freddy77 Exp $
+$Id: ChangeLog,v 1.2754 2009/03/19 13:11:41 freddy77 Exp $
diff --git a/misc/prepare_win32.sh b/misc/prepare_win32.sh
new file mode 100755
index 0000000..5e8e1e1
--- /dev/null
+++ b/misc/prepare_win32.sh
@@ -0,0 +1,325 @@
+#!/bin/bash
+
+# these commands prepare for win32 distribution
+
+errore() {
+	echo $* >&2
+	exit 1
+}
+
+NTWDBLIB=no
+TYPE=win32
+ARCHIVE='tar jcvf "freetds-$PACKAGE_VERSION.$TYPE.tar.bz2" "freetds-$PACKAGE_VERSION"'
+for param
+do
+	case $param in
+	--win64)
+		HOST=x86_64-pc-mingw32
+		TYPE=win64
+		;;
+	--zip)
+		ARCHIVE='zip -r9 "freetds-$PACKAGE_VERSION.$TYPE.zip" "freetds-$PACKAGE_VERSION"'
+		;;
+	--gzip)
+		ARCHIVE='tar zcvf "freetds-$PACKAGE_VERSION.$TYPE.tar.gz" "freetds-$PACKAGE_VERSION"'
+		;;
+	--ntwdblib)
+		NTWDBLIB=yes
+		;;
+	--help)
+		echo "Usage: $0 [OPTION]..."
+		echo '  --help          this help'
+		echo '  --win64         compile for win64'
+		echo '  --zip           compress with zip'
+		echo '  --gzip          compress with gzip'
+		echo '  --ntwdblib      use ntwdblib instead of our'
+		exit 0
+		;;
+	*)
+		echo 'Option not supported! Try --help' 1>&2
+		exit 1
+		;;
+	esac
+done
+
+if test "$TYPE" = "win32"; then
+	HOST=i386-mingw32
+	if ! $HOST-gcc --help > /dev/null 2> /dev/null; then
+		HOST=i586-mingw32msvc
+	fi
+fi
+
+PACKAGE_VERSION=
+eval `grep '^PACKAGE_VERSION=' configure`
+if test "$PACKAGE_VERSION" = ""; then
+	VERSION=
+	eval `grep '^ \?VERSION=' configure`
+	PACKAGE_VERSION="$VERSION"
+fi
+test "$PACKAGE_VERSION" != "" || errore "PACKAGE_VERSION not found"
+test -r "freetds-$PACKAGE_VERSION.tar.gz" || make dist
+test -r "freetds-$PACKAGE_VERSION.tar.gz" || errore "package not found"
+rm -rf "freetds-$PACKAGE_VERSION"
+tar zxvf "freetds-$PACKAGE_VERSION.tar.gz"
+cd "freetds-$PACKAGE_VERSION" || errore "Directory not found"
+
+if ! $HOST-gcc --help > /dev/null 2> /dev/null; then
+	echo $HOST-gcc not found >&2
+	exit 1
+fi
+
+# build
+trap 'echo Error at line $LINENO' ERR
+set -e
+CFLAGS='-O2 -g -pipe' ./configure --host=$HOST --build=i686-pc-linux-gnu
+cp libtool libtool.tmp
+cat libtool.tmp | sed -e 's,file format pe-i386,file format pe-(x86-64|i386),' > libtool
+make -j4 2> errors.txt
+TESTS_ENVIRONMENT=true make -j4 check 2>> errors.txt
+
+# compile dblib test against MS dblib
+if test "$NTWDBLIB" = "yes"; then
+	cd src/dblib
+	# generate new libsybdb.dll.a
+	[ -f .libs/libsybdb.dll.a ] || errore "library libsybdb.dll.a not found"
+
+	# replace libsybdb.dll.a
+	cat > ntwdblib.def <<"_EOF"
+EXPORTS
+SQLDebug
+abort_xact
+bcpDefaultPrefix
+bcp_batch
+bcp_bind
+bcp_colfmt
+bcp_collen
+bcp_colptr
+bcp_columns
+bcp_control
+bcp_done
+bcp_exec
+bcp_init
+bcp_moretext
+bcp_readfmt
+bcp_sendrow
+bcp_setl
+bcp_writefmt
+build_xact_string
+close_commit
+commit_xact
+dbadata
+dbadlen
+dbaltbind
+dbaltcolid
+dbaltlen
+dbaltop
+dbalttype
+dbaltutype
+dbanullbind
+dbbcmd
+dbbind
+dbbylist
+dbcancel
+dbcanquery
+dbchange
+dbclose
+dbclrbuf
+dbclropt
+dbcmd
+dbcmdrow
+dbcolbrowse
+dbcolinfo
+dbcollen
+dbcolname
+dbcolntype
+dbcolsource
+dbcoltype
+dbcolutype
+dbconnectionread
+dbconvert
+dbcount
+dbcurcmd
+dbcurrow
+dbcursor
+dbcursorbind
+dbcursorclose
+dbcursorcolinfo
+dbcursorfetch
+dbcursorfetchex
+dbcursorinfo
+dbcursorinfoex
+dbcursoropen
+dbdata
+dbdataready
+dbdatecrack
+dbdatlen
+dbdead
+dbenlisttrans
+dbenlistxatrans
+dberrhandle
+dbexit
+dbfcmd
+dbfirstrow
+dbfreebuf
+dbfreelogin
+dbfreequal
+dbgetchar
+dbgetmaxprocs
+dbgetoff
+dbgetpacket
+dbgetrow
+dbgettime
+dbgetuserdata
+dbhasretstat
+dbinit
+dbisavail
+dbiscount
+dbisopt
+dblastrow
+dblocklib
+dblogin
+dbmorecmds
+dbmoretext
+dbmsghandle
+dbname
+dbnextrow
+dbnullbind
+dbnumalts
+dbnumcols
+dbnumcompute
+dbnumorders
+dbnumrets
+dbopen
+dbordercol
+dbprhead
+dbprocerrhandle
+dbprocinfo
+dbprocmsghandle
+dbprrow
+dbprtype
+dbqual
+dbreadpage
+dbreadtext
+dbresults
+dbretdata
+dbretlen
+dbretname
+dbretstatus
+dbrettype
+dbrows
+dbrowtype
+dbrpcexec
+dbrpcinit
+dbrpcparam
+dbrpcsend
+dbrpwclr
+dbrpwset
+dbserverenum
+dbsetavail
+dbsetlname
+dbsetlogintime
+dbsetlpacket
+dbsetmaxprocs
+dbsetnull
+dbsetopt
+dbsettime
+dbsetuserdata
+dbsqlexec
+dbsqlok
+dbsqlsend
+dbstrcpy
+dbstrlen
+dbtabbrowse
+dbtabcount
+dbtabname
+dbtabsource
+dbtsnewlen
+dbtsnewval
+dbtsput
+dbtxptr
+dbtxtimestamp
+dbtxtsnewval
+dbtxtsput
+dbunlocklib
+dbupdatetext
+dbuse
+dbvarylen
+dbwillconvert
+dbwinexit
+dbwritepage
+dbwritetext
+open_commit
+remove_xact
+start_xact
+stat_xact
+_EOF
+	$HOST-dlltool --dllname ntwdblib.dll --input-def ntwdblib.def --output-lib .libs/libsybdb.dll.a
+	cd ../..
+
+	# replace includes
+	cd include
+	rm -f dblib.h sqldb.h sqlfront.h sybdb.h syberror.h sybfront.h
+	cp $HOME/cpp/freetds/dblib/sqldb.h sqldb.h
+	cp $HOME/cpp/freetds/dblib/sqlfront.h sqlfront.h
+	cd ..
+
+	# rebuild tests
+	cd src/dblib/unittests
+	rm -f *.o *.exe
+	make clean
+	perl -pi.orig -e '$_ =~ s/$/ -DDBNTWIN32/ if (/^CPPFLAGS\s*=/)' Makefile
+	TESTS_ENVIRONMENT=true make -j4 check 2>> ../../../errors.txt
+	cd ../../..
+fi
+cat errors.txt | grep -v '^.libs/lt-\|^mkdir: cannot create directory ..libs.: File exists$' | perl -ne 'if (/visibility attribute not supported in this configuration/) {$ignore=1;$_=""} else {$ignore=0} ; print $old if !$ignore; $old=$_; END { print $old }' > ../${TYPE}_errors.txt
+rm errors.txt
+
+rm -rf include doc
+find -name Makefile.in  |xargs rm
+find -name \*.in  | grep -v 'unittests\|PWD' | xargs rm
+find \( -type f -o -type l \) -a \( ! -name \*.bat -a ! -name \*.exe -a ! -name \*.def -a ! -name \*.dll -a ! -name \*.be -a ! -name \*.conf -a ! -name \*.exp -a ! -name \*.bin -a ! -name \*.in \) | xargs rm
+
+find -name \*.exe | grep '/\.libs/' | while read X; do mv "${X%/.libs/*}/.libs/${X#*/.libs/}" "${X%/.libs/*}/${X#*/.libs/}"; done
+find -type d -exec rmdir {} \; 2> /dev/null || true
+find src -name .libs -type d | while read X; do mv "$X"/* "${X%/.libs}"; done
+# copy dll inside unitests directories
+find src -name \*.dll | while read X; do D=${X%/*}; test -d "$D/unittests" && cp $X "$D/unittests"; mv $X src/apps; done
+mv src/apps/libtdsodbc-0.dll win32/FreeTDS.dll
+sed 's,Debug\\,,' < win32/installfreetds.bat > win32/installfreetds.bat.new && mv -f win32/installfreetds.bat.new win32/installfreetds.bat
+
+# remove empty directories
+find -type d -exec rmdir {} \; 2> /dev/null || true
+find -type d -exec rmdir {} \; 2> /dev/null || true
+find -type d -exec rmdir {} \; 2> /dev/null || true
+
+# strip any dll or exe
+find -name \*.dll | xargs $HOST-strip
+find -name \*.exe | xargs $HOST-strip
+
+echo '@echo off
+del err.txt ok.txt
+for %%f in (*.exe) do call :processa %%f
+goto fine
+
+:processa
+echo processing %1 ...
+echo start test %1>out.txt
+set OK=1
+%1 >> out.txt 2>&1
+if errorlevel 1 set OK=0
+echo ok %OK%
+echo end test %1>>out.txt
+echo.>>out.txt
+echo.>>out.txt
+echo.>>out.txt
+echo.>>out.txt
+
+if "%OK%"=="0" type out.txt >> err.txt
+if "%OK%"=="1" type out.txt >> ok.txt
+
+:fine
+' > src/odbc/unittests/go.bat
+unix2dos src/odbc/unittests/go.bat
+
+cd ..
+eval "$ARCHIVE"
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index 2dbad1c..fc158ff 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -12,11 +12,9 @@
 #include <sys/param.h>
 #endif /* HAVE_SYS_PARAM_H */
 
-#ifndef DBNTWIN32
 #include "replacements.h"
-#endif
 
-static char software_version[] = "$Id: common.c,v 1.29 2009/02/27 15:52:48 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.30 2009/03/19 13:11:41 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -353,7 +351,7 @@ syb_msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, cha
 	if (dbproc != NULL) {
 		pexpected_msgno = (int *) dbgetuserdata(dbproc);
 		if (pexpected_msgno && *pexpected_msgno == msgno) {
-			fprintf(stdout, "OK: anticipated message arrived: %d %s\n", msgno, msgtext);
+			fprintf(stdout, "OK: anticipated message arrived: %d %s\n", (int) msgno, msgtext);
 			*pexpected_msgno = 0;
 			return 0;
 		}
diff --git a/src/dblib/unittests/common.h b/src/dblib/unittests/common.h
index b0d2e6a..1f5bcb5 100644
--- a/src/dblib/unittests/common.h
+++ b/src/dblib/unittests/common.h
@@ -2,7 +2,7 @@
 #ifndef COMMON_h
 #define COMMON_h
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.17 2009/02/27 15:52:48 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.18 2009/03/19 13:11:41 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #if HAVE_CONFIG_H
@@ -23,6 +23,10 @@ static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_wa
 
 #ifdef DBNTWIN32
 #include <windows.h>
+/* fix MingW missing declare */
+#ifndef _WINDOWS_
+#define _WINDOWS_ 1
+#endif
 #endif
 
 #include <sqlfront.h>
diff --git a/src/dblib/unittests/null.c b/src/dblib/unittests/null.c
index 7563bec..b657b19 100644
--- a/src/dblib/unittests/null.c
+++ b/src/dblib/unittests/null.c
@@ -7,9 +7,11 @@
 
 #include <unistd.h>
 
-static char software_version[] = "$Id: null.c,v 1.7 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: null.c,v 1.8 2009/03/19 13:11:41 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
+#ifndef DBNTWIN32
+
 static DBPROCESS *dbproc = NULL;
 static int failed = 0;
 
@@ -181,4 +183,11 @@ main(int argc, char **argv)
 
 	return failed ? 1 : 0;
 }
+#else
+int main(void)
+{
+	fprintf(stderr, "Not supported by MS DBLib\n");
+	return 0;
+}
+#endif
 
diff --git a/src/dblib/unittests/t0021.c b/src/dblib/unittests/t0021.c
index 2c6bac9..cfc7738 100644
--- a/src/dblib/unittests/t0021.c
+++ b/src/dblib/unittests/t0021.c
@@ -5,10 +5,10 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0021.c,v 1.14 2009/02/01 22:29:39 jklowden Exp $";
+static char software_version[] = "$Id: t0021.c,v 1.15 2009/03/19 13:11:41 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-
+#ifndef DBNTWIN32
 
 int failed = 0;
 
@@ -62,3 +62,10 @@ main(int argc, char **argv)
 	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	return failed ? 1 : 0;
 }
+#else
+int main(void)
+{
+	fprintf(stderr, "Not supported by MS DBLib\n");
+	return 0;
+}
+#endif

